A Knight's Journey

A Knight’s Journey

来源:
标签:深度优先搜索
参考资料:

相似题目:

洛谷 - P1443:马的遍历

题目

Background
The knight is getting bored of seeing the same black and white squares again and again and has decided to make a journey around the world. Whenever a knight moves, it is two squares in one direction and one square perpendicular to this. The world of a knight is the chessboard he is living on. Our knight lives on a chessboard that has a smaller area than a regular 8 * 8 board, but it is still rectangular. Can you help this adventurous knight to make travel plans?
Problem
Find a path such that the knight visits every square once. The knight can start and end on any square of the board.
这里写图片描述

输入

The input begins with a positive integer n in the first line. The following lines contain n test cases. Each test case consists of a single line with two positive integers p and q, such that 1 <= p * q <= 26. This represents a p * q chessboard, where p describes how many different square numbers 1, … , p exist, q describes how many different square letters exist. These are the first q letters of the Latin alphabet: A, …

输出

The output for every scenario begins with a line containing “Scenario #i:”, where i is the number of the scenario starting at 1. Then print a single line containing the lexicographically first path that visits all squares of the chessboard with knight moves followed by an empty line. The path should be given on a single line by concatenating the names of the visited squares. Each square name consists of a capital letter followed by a number.
If no such path exist, you should output impossible on a single line.

输入样例

3
1 1
2 3
4 3

输出样例

Scenario #1:
A1

Scenario #2:
impossible

Scenario #3:
A1B3C1A2B4C2A3B1C3A4B2C4

解题思路

深度优先搜索,因为题目要求找到一条字典序最小的路径,所以搜索的方向要注意。

参考代码

#include<stdio.h>
#include<string.h>
#define MAXN 30
int board[MAXN][MAXN];
int dx[8]={-1, 1,-2, 2,-2, 2,-1, 1},
    dy[8]={-2,-2,-1,-1, 1, 1, 2, 2};
int p,q;
int posx[MAXN],posy[MAXN];
int cnt;
int dfs(int x,int y){
    board[x][y]=1;
    posx[cnt]=x;
    posy[cnt]=y;
    cnt++;
    if(cnt==p*q){
        return 1;
    }
    for(int i=0;i<8;i++){
        int nx=x+dx[i],ny=y+dy[i];
        if(0<=nx && nx<p && 0<=ny && ny<q && board[nx][ny]==0){
            if(dfs(nx,ny)==1)return 1;
            board[nx][ny]=0;
            cnt--;
        }
    }
    return 0;
}
int main(){
    int n;
    scanf("%d",&n);
    int i,j;
    for(i=1;i<=n;i++){
        memset(board,0,sizeof(board));
        cnt=0;
        scanf("%d%d",&p,&q);
        int flag=dfs(0,0);
        printf("Scenario #%d:\n",i);
        if(flag==0){
            printf("impossible\n");
        }
        else{
            for(j=0;j<p*q;j++){
                printf("%c%d",posy[j]+'A',posx[j]+1);
            }
            printf("\n");
        }
        printf("\n");   
    }
    return 0;
}

猜你喜欢

转载自blog.csdn.net/wingrez/article/details/80474741
今日推荐